ur_rna.StructureEditor.windows

## Class DrawWindow

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JInternalFrame
        - - ur_rna.Utilities.swing.MdiChildFrame
          - - ur_rna.StructureEditor.windows.ChildFrame
            - - ur_rna.StructureEditor.windows.DrawWindow

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.RootPaneContainer, javax.swing.WindowConstants

      public class DrawWindow
      extends ChildFrame

  Basic child window for drawing.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `private static class` | `DrawWindow.SceneInfo`
    `static class` | `DrawWindow.ToolButtonList`

    - ### Nested classes/interfaces inherited from class javax.swing.JInternalFrame

      `javax.swing.JInternalFrame.AccessibleJInternalFrame, javax.swing.JInternalFrame.JDesktopIcon`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private RnaFileIO.AsyncTask` | `_asyncTask`
    `(package private) UiAction` | `actionBreakBonds`
    `(package private) UiAction` | `actionChooseStructure`
    `(package private) UiAction` | `actionClose`
    `(package private) UiAction` | `actionColorHelices`
    `(package private) UiAction` | `actionEditNucs`
    `(package private) UiAction` | `actionEditRedo`
    `(package private) UiAction` | `actionEditUndo`
    `(package private) UiAction` | `actionExport`
    `(package private) UiAction` | `actionFlipScene`
    `(package private) UiAction` | `actionFold`
    `(package private) UiAction` | `actionFormatColor`
    `(package private) UiAction` | `actionFormatRemoveAllColor`
    `(package private) UiAction` | `actionFormatRemoveColor`
    `(package private) UiAction` | `actionIdentifyPseudoKnots`
    `(package private) UiAction` | `actionInsertNucs`
    `(package private) UiAction` | `actionJoinStrands`
    `(package private) UiAction` | `actionLocalRedraw`
    `(package private) UiAction` | `actionNextStructure`
    `(package private) UiAction` | `actionPrevStructure`
    `(package private) UiAction` | `actionRedraw`
    `(package private) UiAction` | `actionRedrawCirc`
    `(package private) UiAction` | `actionRedrawLinear`
    `(package private) UiAction` | `actionRemoveNucs`
    `(package private) UiAction` | `actionSave`
    `(package private) UiAction` | `actionSaveAs`
    `(package private) UiAction` | `actionSelectAll`
    `(package private) UiAction` | `actionSelectBranch`
    `(package private) UiAction` | `actionSelectExpand`
    `(package private) UiAction` | `actionSelectHelix`
    `(package private) UiAction` | `actionSelectNuc`
    `(package private) UiAction` | `actionSetBondTypeBanned`
    `(package private) UiAction` | `actionSetBondTypeForced`
    `(package private) UiAction` | `actionSetBondTypeNormal`
    `(package private) UiAction` | `actionSetBondTypePseduo`
    `(package private) UiAction` | `actionSetBondTypeSpecial`
    `(package private) UiAction` | `actionShowEnergy`
    `(package private) UiAction` | `actionSplitStrand`
    `(package private) UiAction` | `actionZoomAuto`
    `(package private) UiAction` | `actionZoomIn`
    `(package private) UiAction` | `actionZoomOut`
    `(package private) UiAction` | `actionZoomReset`
    `private javax.swing.Timer` | `asyncUpdateTimer`
    `private javax.swing.AbstractButton` | `btnSelModeBranch`
    `private javax.swing.AbstractButton` | `btnSelModeHelix`
    `private javax.swing.AbstractButton` | `btnSelModeNuc`
    `RnaDrawController` | `controller`
    `private RnaScene` | `currentScene`
    `private DrawSettings` | `drawSettings`
    `private MergeMenu` | `formatBondType`
    `private NucLayout` | `layout`
    `private javax.swing.JLabel` | `lblTaskProgress`
    `private javax.swing.JLabel` | `lblTaskStatus`
    `private java.util.List<MergeMenu>` | `menus`
    `private DrawPanel` | `panel`
    `private javax.swing.JPanel` | `pnlTaskProgress`
    `private javax.swing.JProgressBar` | `prgTaskProgress`
    `private DrawWindow.SceneInfo[]` | `sceneInfo`
    `private RnaSceneGroup` | `scenes`
    `private javax.swing.JScrollPane` | `scrollPane`
    `(package private) RnaDrawController.SelectionType` | `selType`
    `private ButtonGroupList` | `structureList`
    `private MergeMenu` | `structureMenu`
    `private javax.swing.JButton` | `structureMenuToolbarButton`
    `(package private) UiAction` | `testAction`
    `private DrawWindow.ToolButtonList` | `toolButtons`

    - ### Fields inherited from class javax.swing.JInternalFrame

      `closable, CONTENT_PANE_PROPERTY, desktopIcon, FRAME_ICON_PROPERTY, frameIcon, GLASS_PANE_PROPERTY, iconable, IS_CLOSED_PROPERTY, IS_ICON_PROPERTY, IS_MAXIMUM_PROPERTY, IS_SELECTED_PROPERTY, isClosed, isIcon, isMaximum, isSelected, LAYERED_PANE_PROPERTY, maximizable, MENU_BAR_PROPERTY, resizable, ROOT_PANE_PROPERTY, rootPane, rootPaneCheckingEnabled, title, TITLE_PROPERTY`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface javax.swing.WindowConstants

      `DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawWindow()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `asyncTimer_elapsed()`
    `void` | `autoScale()`
    `private void` | `buildStructureMenu()`
    `void` | `colorizeScenes(SceneColorizer c, boolean applyToAllScenes, boolean selectedBasesOnly)`
    `private void` | `createMenus()`
    `private void` | `createToolButtons()`
    `private void` | `createUI()`
    `void` | `editSelectedBases()`
    `private void` | `findHelices()`
    `private void` | `findPseudoKnots()`
    `private void` | `findPseudoKnotsBackend()`
    `private void` | `foldSequence()`
    `RnaScene` | `getCurrentScene()`
    `private int` | `getCurrentSceneIndex()`
    `java.util.Collection<? extends javax.swing.JMenu>` | `getMenus()`
    `private java.awt.Rectangle` | `getSceneBounds(boolean includeInteractive)`
    `RnaSceneGroup` | `getScenes()`
    `java.util.Collection<? extends java.awt.Component>` | `getToolbarButtons()`
    `private void` | `handleView(RnaScene scene, boolean save)`
    `private void` | `insertBases()`
    `private boolean` | `isTaskRunning()`
    `void` | `loadFile(RnaSceneGroup file)`
    `void` | `loadScene(RnaScene scene)`
    `private void` | `loadSettings()`
    `private void` | `loadStructure(int structureIndex)`
    `private void` | `monitorAsyncTask(RnaFileIO.AsyncTask task)`
    `private void` | `onHistoryUpdate(HistoryUpdateEvent event)`
    `private void` | `onSceneUpdate(SceneUpdateEvent event)`
    `void` | `programSettingsUpdated()` Called when Program Settings have changed.
    `private void` | `redrawCircular()`
    `private void` | `redrawLinear()`
    `void` | `redrawScene()`
    `private java.awt.Rectangle` | `renderFullSceneToImage(java.awt.Graphics2D imageGraphics, boolean opaque)`
    `private void` | `save(FileType type, boolean forceSaveAs, boolean export)`
    `private void` | `saveSceneAsRastorImage(java.lang.String path, FileType type)`
    `private void` | `saveSceneAsVectorImage(java.lang.String path, FileType type)`
    `void` | `setSelectedBondType(BondType type)`
    `void` | `setSelMode(RnaDrawController.SelectionType selMode)`
    `private void` | `setSelType(RnaDrawController.SelectionType selType)`
    `void` | `showCalcEnergy()`
    `private void` | `showColorizeDialog()`
    `private void` | `showNextStructure()`
    `private void` | `showPrevStructure()`
    `private void` | `showStructureMenu()`
    `private java.lang.String` | `strOrDefault(java.lang.String value, java.lang.String defaultIfEmpty)`
    `private void` | `test()`
    `private void` | `updateFileUI()`
    `private void` | `updateSelectionUI()`

    - ### Methods inherited from class ur_rna.StructureEditor.windows.ChildFrame

      `close`

    - ### Methods inherited from class ur_rna.Utilities.swing.MdiChildFrame

      `addAction, addKeyBinding, addKeyBinding, getParentFrame, setParentFrame`

    - ### Methods inherited from class javax.swing.JInternalFrame

      `addImpl, addInternalFrameListener, createRootPane, dispose, doDefaultCloseAction, fireInternalFrameEvent, getAccessibleContext, getContentPane, getDefaultCloseOperation, getDesktopIcon, getDesktopPane, getFocusCycleRootAncestor, getFocusOwner, getFrameIcon, getGlassPane, getInternalFrameListeners, getJMenuBar, getLastCursor, getLayer, getLayeredPane, getMenuBar, getMostRecentFocusOwner, getNormalBounds, getRootPane, getTitle, getUI, getUIClassID, getWarningString, hide, isClosable, isClosed, isFocusCycleRoot, isIcon, isIconifiable, isMaximizable, isMaximum, isResizable, isRootPaneCheckingEnabled, isSelected, moveToBack, moveToFront, pack, paintComponent, paramString, remove, removeInternalFrameListener, reshape, restoreSubcomponentFocus, setClosable, setClosed, setContentPane, setCursor, setDefaultCloseOperation, setDesktopIcon, setFocusCycleRoot, setFrameIcon, setGlassPane, setIcon, setIconifiable, setJMenuBar, setLayer, setLayer, setLayeredPane, setLayout, setMaximizable, setMaximum, setMenuBar, setNormalBounds, setResizable, setRootPane, setRootPaneCheckingEnabled, setSelected, setTitle, setUI, show, toBack, toFront, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _asyncTask

          private RnaFileIO.AsyncTask _asyncTask

    - #### actionBreakBonds

          UiAction actionBreakBonds

    - #### actionChooseStructure

          UiAction actionChooseStructure

    - #### actionClose

          UiAction actionClose

    - #### actionColorHelices

          UiAction actionColorHelices

    - #### actionEditNucs

          UiAction actionEditNucs

    - #### actionEditRedo

          UiAction actionEditRedo

    - #### actionEditUndo

          UiAction actionEditUndo

    - #### actionExport

          UiAction actionExport

    - #### actionFlipScene

          UiAction actionFlipScene

    - #### actionFold

          UiAction actionFold

    - #### actionFormatColor

          UiAction actionFormatColor

    - #### actionFormatRemoveAllColor

          UiAction actionFormatRemoveAllColor

    - #### actionFormatRemoveColor

          UiAction actionFormatRemoveColor

    - #### actionIdentifyPseudoKnots

          UiAction actionIdentifyPseudoKnots

    - #### actionInsertNucs

          UiAction actionInsertNucs

    - #### actionJoinStrands

          UiAction actionJoinStrands

    - #### actionLocalRedraw

          UiAction actionLocalRedraw

    - #### actionNextStructure

          UiAction actionNextStructure

    - #### actionPrevStructure

          UiAction actionPrevStructure

    - #### actionRedraw

          UiAction actionRedraw

    - #### actionRedrawCirc

          UiAction actionRedrawCirc

    - #### actionRedrawLinear

          UiAction actionRedrawLinear

    - #### actionRemoveNucs

          UiAction actionRemoveNucs

    - #### actionSave

          UiAction actionSave

    - #### actionSaveAs

          UiAction actionSaveAs

    - #### actionSelectAll

          UiAction actionSelectAll

    - #### actionSelectBranch

          UiAction actionSelectBranch

    - #### actionSelectExpand

          UiAction actionSelectExpand

    - #### actionSelectHelix

          UiAction actionSelectHelix

    - #### actionSelectNuc

          UiAction actionSelectNuc

    - #### actionSetBondTypeBanned

          UiAction actionSetBondTypeBanned

    - #### actionSetBondTypeForced

          UiAction actionSetBondTypeForced

    - #### actionSetBondTypeNormal

          UiAction actionSetBondTypeNormal

    - #### actionSetBondTypePseduo

          UiAction actionSetBondTypePseduo

    - #### actionSetBondTypeSpecial

          UiAction actionSetBondTypeSpecial

    - #### actionShowEnergy

          UiAction actionShowEnergy

    - #### actionSplitStrand

          UiAction actionSplitStrand

    - #### actionZoomAuto

          UiAction actionZoomAuto

    - #### actionZoomIn

          UiAction actionZoomIn

    - #### actionZoomOut

          UiAction actionZoomOut

    - #### actionZoomReset

          UiAction actionZoomReset

    - #### asyncUpdateTimer

          private javax.swing.Timer asyncUpdateTimer

    - #### btnSelModeBranch

          private javax.swing.AbstractButton btnSelModeBranch

    - #### btnSelModeHelix

          private javax.swing.AbstractButton btnSelModeHelix

    - #### btnSelModeNuc

          private javax.swing.AbstractButton btnSelModeNuc

    - #### controller

          public final RnaDrawController controller

    - #### currentScene

          private RnaScene currentScene

    - #### drawSettings

          private DrawSettings drawSettings

    - #### formatBondType

          private MergeMenu formatBondType

    - #### layout

          private NucLayout layout

    - #### lblTaskProgress

          private javax.swing.JLabel lblTaskProgress

    - #### lblTaskStatus

          private javax.swing.JLabel lblTaskStatus

    - #### menus

          private java.util.List<MergeMenu> menus

    - #### panel

          private DrawPanel panel

    - #### pnlTaskProgress

          private javax.swing.JPanel pnlTaskProgress

    - #### prgTaskProgress

          private javax.swing.JProgressBar prgTaskProgress

    - #### sceneInfo

          private DrawWindow.SceneInfo[] sceneInfo

    - #### scenes

          private RnaSceneGroup scenes

    - #### scrollPane

          private javax.swing.JScrollPane scrollPane

    - #### selType

          RnaDrawController.SelectionType selType

    - #### structureList

          private ButtonGroupList structureList

    - #### structureMenu

          private MergeMenu structureMenu

    - #### structureMenuToolbarButton

          private javax.swing.JButton structureMenuToolbarButton

    - #### testAction

          UiAction testAction

    - #### toolButtons

          private DrawWindow.ToolButtonList toolButtons

  - ### Constructor Detail

    - #### DrawWindow

          public DrawWindow()

  - ### Method Detail

    - #### asyncTimer_elapsed

          private void asyncTimer_elapsed()

    - #### autoScale

          public void autoScale()

    - #### buildStructureMenu

          private void buildStructureMenu()

    - #### colorizeScenes

          public void colorizeScenes(SceneColorizer c,
                                     boolean applyToAllScenes,
                                     boolean selectedBasesOnly)

    - #### createMenus

          private void createMenus()

    - #### createToolButtons

          private void createToolButtons()

    - #### createUI

          private void createUI()

    - #### editSelectedBases

          public void editSelectedBases()

    - #### findHelices

          private void findHelices()

    - #### findPseudoKnots

          private void findPseudoKnots()

    - #### findPseudoKnotsBackend

          private void findPseudoKnotsBackend()

    - #### foldSequence

          private void foldSequence()

    - #### getCurrentScene

          public RnaScene getCurrentScene()

    - #### getCurrentSceneIndex

          private int getCurrentSceneIndex()

    - #### getMenus

          public java.util.Collection<? extends javax.swing.JMenu> getMenus()

      Overrides:
        `getMenus` in class `ChildFrame`

    - #### getSceneBounds

          private java.awt.Rectangle getSceneBounds(boolean includeInteractive)

    - #### getScenes

          public RnaSceneGroup getScenes()

    - #### getToolbarButtons

          public java.util.Collection<? extends java.awt.Component> getToolbarButtons()

      Overrides:
        `getToolbarButtons` in class `ChildFrame`

    - #### handleView

          private void handleView(RnaScene scene,
                                  boolean save)

    - #### insertBases

          private void insertBases()

    - #### isTaskRunning

          private boolean isTaskRunning()

    - #### loadFile

          public void loadFile(RnaSceneGroup file)

    - #### loadScene

          public void loadScene(RnaScene scene)

    - #### loadSettings

          private void loadSettings()

    - #### loadStructure

          private void loadStructure(int structureIndex)

    - #### monitorAsyncTask

          private void monitorAsyncTask(RnaFileIO.AsyncTask task)

    - #### onHistoryUpdate

          private void onHistoryUpdate(HistoryUpdateEvent event)

    - #### onSceneUpdate

          private void onSceneUpdate(SceneUpdateEvent event)

    - #### programSettingsUpdated

          public void programSettingsUpdated()

      Description copied from class: `ChildFrame`
      Called when Program Settings have changed. ChildFrame descendants can override this to perform custom updates as necessary.
      Overrides:
        `programSettingsUpdated` in class `ChildFrame`

    - #### redrawCircular

          private void redrawCircular()

    - #### redrawLinear

          private void redrawLinear()

    - #### redrawScene

          public void redrawScene()

    - #### renderFullSceneToImage

          private java.awt.Rectangle renderFullSceneToImage(java.awt.Graphics2D imageGraphics,
                                                            boolean opaque)

    - #### save

          private void save(FileType type,
                            boolean forceSaveAs,
                            boolean export)

    - #### saveSceneAsRastorImage

          private void saveSceneAsRastorImage(java.lang.String path,
                                              FileType type)
                                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### saveSceneAsVectorImage

          private void saveSceneAsVectorImage(java.lang.String path,
                                              FileType type)
                                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### setSelectedBondType

          public void setSelectedBondType(BondType type)

    - #### setSelMode

          public void setSelMode(RnaDrawController.SelectionType selMode)

    - #### setSelType

          private void setSelType(RnaDrawController.SelectionType selType)

    - #### showCalcEnergy

          public void showCalcEnergy()

    - #### showColorizeDialog

          private void showColorizeDialog()

    - #### showNextStructure

          private void showNextStructure()

    - #### showPrevStructure

          private void showPrevStructure()

    - #### showStructureMenu

          private void showStructureMenu()

    - #### strOrDefault

          private java.lang.String strOrDefault(java.lang.String value,
                                                java.lang.String defaultIfEmpty)

    - #### test

          private void test()

    - #### updateFileUI

          private void updateFileUI()

    - #### updateSelectionUI

          private void updateSelectionUI()